## org.apache.commons.math.ode.jacobians
Class FirstOrderIntegratorWithJacobians.EventHandlerWrapper

    java.lang.Object
      org.apache.commons.math.ode.jacobians.FirstOrderIntegratorWithJacobians.EventHandlerWrapper

All Implemented Interfaces:
  EventHandler

Enclosing class:
  FirstOrderIntegratorWithJacobians

    private static class FirstOrderIntegratorWithJacobians.EventHandlerWrapper

extends java.lang.Object
implements EventHandler

Wrapper for event handlers.

Field Summary
`private double[][]` `dydp` Jacobian with respect to parameters dy/dp.
`private double[][]` `dydy0` Jacobian with respect to initial state dy/dy0.
`private EventHandlerWithJacobians` `handler` Underlying event handler with jacobians.
`private double[]` `y` State array.

Fields inherited from interface org.apache.commons.math.ode.events.EventHandler
`CONTINUE, RESET_DERIVATIVES, RESET_STATE, STOP`

Constructor Summary
`FirstOrderIntegratorWithJacobians.EventHandlerWrapper(EventHandlerWithJacobians handler, int n, int k)` Simple constructor.

Method Summary
`int` `eventOccurred(double t, double[] z, boolean increasing)` Handle an event and choose what to do next.
`double` `g(double t, double[] z)` Compute the value of the switching function.
`EventHandlerWithJacobians` `getHandler()` Get the underlying event handler with jacobians.
`void` `resetState(double t, double[] z)` Reset the state prior to continue the integration.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### handler

    private final EventHandlerWithJacobians handler

  Underlying event handler with jacobians.

### y

    private double[] y

  State array.

### dydy0

    private double[][] dydy0

  Jacobian with respect to initial state dy/dy0.

### dydp

    private double[][] dydp

  Jacobian with respect to parameters dy/dp.

Constructor Detail

### FirstOrderIntegratorWithJacobians.EventHandlerWrapper

    public FirstOrderIntegratorWithJacobians.EventHandlerWrapper(EventHandlerWithJacobians handler,
                                                                 int n,
                                                                 int k)

  Simple constructor.

  Parameters:
    `handler` - underlying event handler with jacobians
    `n` - dimension of the original ODE
    `k` - number of parameters

Method Detail

### getHandler

    public EventHandlerWithJacobians getHandler()

  Get the underlying event handler with jacobians.

  Returns:
    underlying event handler with jacobians

### eventOccurred

    public int eventOccurred(double t,
                             double[] z,
                             boolean increasing)
                      throws EventException

  Handle an event and choose what to do next.

  This method is called when the integrator has accepted a step ending exactly on a sign change of the function, just before the step handler itself is called (see below for scheduling). It allows the user to update his internal data to acknowledge the fact the event has been handled (for example setting a flag in the `differential equations` to switch the derivatives computation in case of discontinuity), or to direct the integrator to either stop or continue integration, possibly with a reset state or derivatives.

  - if `EventHandler.STOP` is returned, the step handler will be called with the `isLast` flag of the `handleStep` method set to true and the integration will be stopped,
  - if `EventHandler.RESET_STATE` is returned, the `resetState` method will be called once the step handler has finished its task, and the integrator will also recompute the derivatives,
  - if `EventHandler.RESET_DERIVATIVES` is returned, the integrator will recompute the derivatives,
  - if `EventHandler.CONTINUE` is returned, no specific action will be taken (apart from having called this method) and integration will continue.

  The scheduling between this method and the `StepHandler` method `handleStep(interpolator, isLast)` is to call this method first and `handleStep` afterwards. This scheduling allows the integrator to pass `true` as the `isLast` parameter to the step handler to make it aware the step will be the last one if this method returns `EventHandler.STOP`. As the interpolator may be used to navigate back throughout the last step (as `StepNormalizer` does for example), user code called by this method and user code called by step handlers may experience apparently out of order values of the independent time variable. As an example, if the same user object implements both this `EventHandler` interface and the `FixedStepHandler` interface, a forward integration may call its `eventOccurred` method with t = 10 first and call its `handleStep` method with t = 9 afterwards. Such out of order calls are limited to the size of the integration step for `variable step handlers` and to the size of the fixed step for `fixed step handlers`.

  Specified by:
    `eventOccurred` in interface `EventHandler`
  Parameters:
    `t` - current value of the independent time variable
    `z` - array containing the current value of the state vector
    `increasing` - if true, the value of the switching function increases when times increases around event (note that increase is measured with respect to physical time, not with respect to integration which may go backward in time)
  Returns:
    indication of what the integrator should do next, this value must be one of `EventHandler.STOP`, `EventHandler.RESET_STATE`, `EventHandler.RESET_DERIVATIVES` or `EventHandler.CONTINUE`
  Throws:
    `EventException` - if the event occurrence triggers an error

### g

    public double g(double t,
                    double[] z)
             throws EventException

  Compute the value of the switching function.

  The discrete events are generated when the sign of this switching function changes. The integrator will take care to change the stepsize in such a way these events occur exactly at step boundaries. The switching function must be continuous in its roots neighborhood (but not necessarily smooth), as the integrator will need to find its roots to locate precisely the events.

  Specified by:
    `g` in interface `EventHandler`
  Parameters:
    `t` - current value of the independent time variable
    `z` - array containing the current value of the state vector
  Returns:
    value of the g switching function
  Throws:
    `EventException` - if the switching function cannot be evaluated

### resetState

    public void resetState(double t,
                           double[] z)
                    throws EventException

  Reset the state prior to continue the integration.

  This method is called after the step handler has returned and before the next step is started, but only when `EventHandler.eventOccurred(double, double[], boolean)` has itself returned the `EventHandler.RESET_STATE` indicator. It allows the user to reset the state vector for the next step, without perturbing the step handler of the finishing step. If the `EventHandler.eventOccurred(double, double[], boolean)` never returns the `EventHandler.RESET_STATE` indicator, this function will never be called, and it is safe to leave its body empty.

  Specified by:
    `resetState` in interface `EventHandler`
  Parameters:
    `t` - current value of the independent time variable
    `z` - array containing the current value of the state vector the new state should be put in the same array
  Throws:
    `EventException` - if the state cannot be reseted

Copyright (c) 2003-2011 Apache Software Foundation